#include <lpc214x.h>
#include "func.h"
//definicja linii ster wyswietlacza
#define E 1<<30
#define RS 1<<31

void InicLcd(void){
 	IO0DIR|=E;//linia E wyjsciowa
	IO0DIR|=RS;//linia RS wyjsciowa
	IO1DIR|=(0xff<<16);//P1.16...P1.23 wyjsciowe
	IOCLR1=0;
	IOSET1=0;
	delay_ms(50);

	WrLcdCmd(0x30);//function set 8 bitow
	delay_ms(6);
	WrLcdCmd(0x30);//function set 8 bitow
	delay_ms(6);
	WrLcdCmd(0x30);//function set 8 bitow
	delay_ms(6);
	WrLcdCmd(0x38);//function set 8 bitow
	WrLcdCmd(8);
	WrLcdCmd(1);
	WrLcdCmd(0x0c);			
}
void DispHex(unsigned char data, unsigned char addr){
unsigned char temp;
	
	WrLcdAddr(addr);//pozycja
	temp=data>>4;
	if(temp<10)
	WrLcdData(temp+0x30);
	else
	WrLcdData(temp+0x37);
	temp=(data&0x0f);
	if(temp<10)
	WrLcdData(temp+0x30);
	else
	WrLcdData(temp+0x37);
}
void DispLcd(const char *napis,char addr)
{
	WrLcdAddr(addr);//pozycja		
    while(*napis!=0)	
	{WrLcdData(*napis);
    ++napis;}
} 
//zapisanie komendy
void WrLcdCmd(unsigned char cmd){
	IOCLR0|=RS;//RS=0 zapis komendy
	LcdBusWrite(cmd);
	delay_ms(2);
}
void WrLcdAddr(unsigned char addr){
 	WrLcdCmd(addr|0x80);
}
void WrLcdData(unsigned char data){
	IOSET0|=RS;//RS=1 zapis danej
	LcdBusWrite(data);
	delay_ms(2);
}
void LcdBusWrite(unsigned char data)
{
 	IOCLR0|=E;delay();delay();delay();delay();//E=0;
	IOSET0|=E; delay();//E=1
	IO1DIR|=(0xff<<16);//bity P1.16....P1.23 wyjscie
	int temp=(data<<16);
	IOCLR1=0x00ff0000;delay();//zeruj bity P1.16...P1.23
	IOSET1=temp; delay();//dane na swoim miejscu	
	IOCLR0|=E;delay();//E=0;

}
void delay(void){
int i;
	for(i=0;i<50;i++)
	;
}

