#include <lpc214x.h>
#include "func.h"
volatile unsigned int msek=0;
extern unsigned char  msd_buffer[512];

void tc0 (void) __attribute__ ((interrupt));
void tc0 (void) {

	++msek;
  	T0IR=1;//zerowanie flagi przerwania od kanau 0 
  	VICVectAddr=0;//update priority hardware
}
int main(void){
//unsigned short i;
unsigned int sd_c;
    init_TMT0();
	InicLcd();
	//DispLcd("SD card:",0);
	
	init_SPI();

	
	
	if(!MediaInitialize())
	{
	  sd_c=sd_cap();
	  DispLcd("SD cap:",0);
	  delay();
	  DispHex(sd_c>>24,0x40);
	  DispHex(sd_c>>16,0x42);
	  DispHex(sd_c>>8,0x44);
	  DispHex(sd_c,0x46);
	}
	else
	{DispLcd("SD card:",0);
	 DispLcd("init_err:",0x40);}


 
	while(1);
}

void init_TMT0(void){  //inicjalizacja Timer0
  T0TCR=0;//zablokowanie Timer0
  T0PR=0;//preskaler
  T0PC=0;
  T0TC=0;//rejestr licznika
  T0MR0=12000;//match kanal 0
  T0MCR=3;//zglaszanie  przerwania i zerowanie licznika kiedy TC0=T0MR0
  //inicjalizacja przerwan od Timer1
  VICVectCntl1=0x24;//odblokowanie IRQ1 i przerwanie od Timer0
  VICVectAddr1 = (unsigned long)tc0;//wektor przerwania IRQ1
  VICIntEnable=0x10;//odblokowanie przerwania od Timer0 
  T0TCR=1;//strat licznika TIMER1
  //T0TCR=1;//strat licznika
}

void delay_ms(unsigned int ms){
	msek=0;
	while(msek<ms);
}
